package brains
{
import flash.display.BitmapData;
import flash.display.DisplayObject;
import flash.display.DisplayObjectContainer;
import flash.display.Sprite;
import flash.geom.Matrix;
import flash.geom.Point;

public class OnOffObjectsBrain
{
	public function OnOffObjectsBrain(container:DisplayObjectContainer, objectType:Class, bitmapRect:Point = null)
	{
		this.container = container;
		this.objectType = objectType;
		this.isBitmapData = (bitmapRect != null);
		if (isBitmapData)
		{
			bitmapData = new objectType(bitmapRect.x, bitmapRect.y);
			bitmapOffset = new Matrix(1, 0, 0, 1, -bitmapRect.x/2, -bitmapRect.y/2);
		}
	}
	
	private var container:DisplayObjectContainer;
	private var objectType:Class;
	private var isBitmapData:Boolean;
	private var bitmapData:BitmapData;
	private var bitmapOffset:Matrix;
	private var objects:Vector.<DisplayObject>;
	private var objectCount:int = 0;
	private var currentVisible:Number = 0;
	
	public function create(count:int, boundX:int, boundY:int, cache:Boolean = false):void
	{
		objectCount = count;
		objects = new Vector.<DisplayObject>(objectCount);
		var yRate:int = (count < 100) ? 60 : 30;
		var row:Number = int(boundY/yRate);
		var col:Number = (count / row);
		var xRate:Number = boundX / col;
		var i:int = count;
		while (i-- > 0)
		{
			var obj:DisplayObject 
			if (isBitmapData)
			{
				obj = new Sprite();
				var shape:Sprite = obj as Sprite;
				shape.graphics.beginBitmapFill(bitmapData, bitmapOffset, false, true);
				shape.graphics.drawRect(-15, -15, 30, 30);
				shape.graphics.endFill();
			}
			else
			{
				obj = new objectType();
			}
			obj.x = ((i%col) * xRate)+15;
			obj.y = (int(i /col) * yRate)+15;
			container.addChild(obj);
			objects[i] = obj;
			
			if (cache)
			{
				obj.cacheAsBitmap = true;
				obj.cacheAsBitmapMatrix = new Matrix();
			}
		}
	}
	
	public function logic(frameCount:int):void
	{
		currentVisible = frameCount % 3;
	}
	
	public function render():void
	{
		var i:int = objectCount;
		while (i-- > 0)
		{
			objects[i].visible = (i % 3 == currentVisible);
		}
	}
	
}
}