package brains
{
import flash.display.BitmapData;
import flash.display.DisplayObjectContainer;
import flash.display.Sprite;
import flash.geom.Matrix;

public class WalkingCycleBDBrain
{
	public function WalkingCycleBDBrain(container:DisplayObjectContainer, bitmaps:Vector.<BitmapData>)
	{
		this.container = container;
		this.bitmaps = bitmaps;
		this.bitmapCount = bitmaps.length;
		bitmapOffset = new Matrix();
	}
	
	private var container:DisplayObjectContainer;
	private var bitmaps:Vector.<BitmapData>;
	private var objects:Vector.<Sprite>;
	private var bitmapOffset:Matrix;
	private var objectCount:int = 0;
	private var bitmapCount:int = 0;
	private var blitFrame:int = 0;
	private var col:Number = 0;
	private var xRate:Number = 0;
	private var lastVisibleFrame:int = -1;
	
	public function create(count:int, boundX:int, boundY:int, cache:Boolean = false):void
	{
		objectCount = count;
		objects = new Vector.<Sprite>(objectCount*bitmapCount, true);
		var yRate:int = 130;
		var row:Number = int(boundY/yRate);
		col = (count / row);
		xRate = boundX / col;
		var i:int = count;
		while (i-- > 0)
		{
			var xPos:Number = -80; // ((i%col) * xRate)
			var yPos:Number = (int(i /col) * yRate)+15;
			for (var j:int = 0; j < bitmapCount; j++)
			{
				var obj:Sprite = new Sprite();
				obj.graphics.beginBitmapFill(bitmaps[j] as BitmapData, bitmapOffset, false, true);
				obj.graphics.drawRect(0, 0, 73, 141);
				obj.graphics.endFill();
				obj.x = xPos;
				obj.y = yPos;
				obj.cacheAsBitmap = true;
				obj.cacheAsBitmapMatrix = new Matrix();
				container.addChild(obj);
				objects[(i * bitmapCount)+j] = obj;
				//obj.visible = false;
			}
		}
	}
	
	public function logic(frameCount:int):void
	{
		// Math.floor inlined
		blitFrame = ((frameCount%16)/2)|0;
	}
	public function render():void
	{
		if (lastVisibleFrame == blitFrame)
			return;
		var i:int = objectCount;
		var key:int = 0;
		while (i-- > 0)
		{
			key = (i * bitmapCount) + blitFrame;
			objects[key].x = ((i%col) * xRate);
			if (lastVisibleFrame > -1)
			{
				key = (i * bitmapCount) + lastVisibleFrame;
				objects[key].x = -80;
			}
		}
		lastVisibleFrame = blitFrame;
	}
	/*
	public function render():void
	{
		if (lastVisibleFrame == blitFrame)
			return;
		var i:int = objectCount;
		var key:int = 0;
		while (i-- > 0)
		{
			key = (i * bitmapCount) + blitFrame;
			objects[key].visible = true;
			if (lastVisibleFrame > -1)
			{
				key = (i * bitmapCount) + lastVisibleFrame;
				objects[key].visible = false;
			}
		}
		lastVisibleFrame = blitFrame;
	}
	*/
	
}
}