package brains
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	public class WalkingCycleBlitSmallBrain
	{
		public function WalkingCycleBlitSmallBrain(container:DisplayObjectContainer, objectType:Class, blitBounds:Rectangle, cache:Boolean = false)
		{
			this.container = container;
			this.blitBounds = blitBounds;
			frameWidth = blitBounds.width;
			
			canvas =  new BitmapData(240, 160, true, 0xFFFFFF);
			//this.container.addChild(new Bitmap(canvas));
			var obj:Sprite = new Sprite();
			obj.addChild(new Bitmap(canvas));
			obj.scaleX = 2;
			obj.scaleY = 2;
			if (cache)
			{
				obj.cacheAsBitmap = true;
				var matrix:Matrix = new Matrix();
				matrix.scale(2, 2);
				obj.cacheAsBitmapMatrix = matrix;
			}
			this.container.addChild(obj);
			bitmapData = new objectType(blitBounds.width, blitBounds.height);
		}
		
		private var container:DisplayObjectContainer;
		private var canvas:BitmapData;
		private var bitmapData:BitmapData;
		private var blitBounds:Rectangle;
		private var frameWidth:Number = 0;
		private var objects:Vector.<Point>;
		private var objectCount:int = 0;
		private var blitFrame:int = 0;
		private var canvasClearRect:Rectangle = new Rectangle(0, 0, 240, 160);
		
		public function create(count:int, boundX:int, boundY:int, cache:Boolean = false):void
		{
			objectCount = count;
			objects = new Vector.<Point>(objectCount);
			var yRate:int = 60;//(count < 100) ? 60 : 30;
			var row:Number = int(boundY/yRate);
			var col:Number = (count / row);
			var xRate:Number = boundX / col;
			var i:int = count;
			while (i-- > 0)
			{
				objects[i] = new Point(((i%col) * xRate), (int(i /col) * yRate));
			}
		}
		
		public function logic(frameCount:int):void
		{
			
			// Math.floor inlined
			blitFrame = (frameCount%16)/2;
			blitFrame = (blitFrame == int(blitFrame)) ? blitFrame : blitFrame < 0 ? int(blitFrame-1) : int(blitFrame);
		}
		
		public function render():void
		{
			var i:int = objectCount;
			blitBounds.x = blitFrame * frameWidth;
			canvas.lock();
			canvas.fillRect(canvasClearRect, 0x000000);
			while (i-- > 0)
			{
				var point:Point = objects[i] as Point;
				canvas.copyPixels(bitmapData, blitBounds, point, null, null, true);
			}
			canvas.unlock();
		}
		
	}
}