package brains
{
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.MovieClip;
	import flash.geom.Matrix;
	
	public class WalkingCycleMCBrain
	{
		public function WalkingCycleMCBrain(container:DisplayObjectContainer, objectType:Class)
		{
			this.container = container;
			this.objectType = objectType;
		}
		
		private var container:DisplayObjectContainer;
		private var objectType:Class;
		private var objects:Vector.<DisplayObject>;
		private var objectCount:int = 0;
		private var val:Number;
		
		public function create(count:int, boundX:int, boundY:int, cache:Boolean = false):void
		{
			objectCount = count;
			objects = new Vector.<DisplayObject>(objectCount);
			var yRate:int = 120;//(count < 100) ? 60 : 30;
			var row:Number = int(boundY/yRate);
			var col:Number = (count / row);
			var xRate:Number = boundX / col;
			var i:int = count;
			while (i-- > 0)
			{
				var obj:DisplayObject = new objectType();
				obj.x = ((i%col) * xRate)+30;
				obj.y = (int(i /col) * yRate)+120;
				container.addChild(obj);
				objects[i] = obj;
				
				if (cache)
				{
					obj.cacheAsBitmap = true;
					obj.cacheAsBitmapMatrix = new Matrix();
				}
			}
		}
		
		public function stop():void
		{
			var i:int = objectCount;
			while (i-- > 0)
			{
				(objects[i] as MovieClip).stop();
			}
		}
		
		public function render(frameCount:int):void
		{
			// Math.floor inlined
			val = (frameCount%32)/4;
			val = (val == int(val)) ? val : val < 0 ? int(val-1) : int(val);
			var i:int = objectCount;
			while (i-- > 0)
			{
				(objects[i] as MovieClip).gotoAndStop(val+1);
			}
		}
		
	}
}